require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Cast.
    module Cast
      # @see Cast#verify_cast_existence
      class CastVerifyCastExistence < UU::OS::REST::DTO

        # @see Cast#verify_cast_existence
        attr_accessor :cast_subject_uri

        # @see Cast#verify_cast_existence
        attr_accessor :cast_subject_universe_id

        # @see Cast#verify_cast_existence
        attr_accessor :subject_uris
        def cast_subject_uri
          attributes[:castSubjectUri]
        end

        def cast_subject_uri=(val)
          if val
            attributes[:castSubjectUri] = UU::OS::UESURI.new(val)
          else
            attributes[:castSubjectUri] = nil
          end
        end

        def cast_subject_universe_id
          attributes[:castSubjectUniverseId]
        end

        def cast_subject_universe_id=(val)
          if val
            attributes[:castSubjectUniverseId] = val
          else
            attributes[:castSubjectUniverseId] = nil
          end
        end

        def subject_uris
          attributes[:subjectUris]
        end

        def subject_uris=(val)
          attributes[:subjectUris] = val
        end

      end
    end

  end

end
