require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Permission.
    module Permission
      # @see Permission#revoke
      class PermissionRevoke < UU::OS::REST::DTO

        # @see Permission#revoke
        attr_accessor :authority_uri

        # @see Permission#revoke
        # @deprecated (since 8-14) It will not be possible to set permissions for individual use cases in new version of authorization.
        attr_accessor :data

        # @see Permission#revoke
        attr_accessor :all
        
        # @deprecated (since 8-14) It will not be possible to set permissions for individual use cases in new version of authorization.
        def data
          attributes[:data]
        end

        # @deprecated (since 8-14) It will not be possible to set permissions for individual use cases in new version of authorization.
        def data=(val)
          if val
            attributes[:data] = UU::OS::REST::BinaryValue.new(val)
          else
            attributes[:data] = nil
          end
        end

        def all
          attributes[:all]
        end

        def all=(val)
          attributes[:all] = val
        end

        def authority_uri
          attributes[:authorityUri]
        end

        def authority_uri=(val)
          if val
            attributes[:authorityUri] = UU::OS::UESURI.new(val)
          else
            attributes[:authorityUri] = nil
          end
        end

      end
    end

  end
end

