require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Application Deployment Kit.
  module OS
    # Module Widget.
    module Widget
      # @see Widget#set_attributes
      class WidgetSetAttributes < UU::OS::REST::DTO

        # @see Widget#set_attributes
        attr_accessor :name

        # @see Widget#set_attributes
        attr_accessor :code

        # @see Widget#set_attributes
        attr_accessor :description

        # @see Widget#set_attributes
        attr_accessor :security_level

        # @see Widget#set_attributes
        attr_accessor :icon_uri

        # @see Widget#set_attributes
        attr_accessor :controller_url_path

        # @see Widget#set_attributes
        attr_accessor :trusted

        # @see Widget#set_attributes
        attr_accessor :editor_available

        # @see Widget#set_attributes
        attr_accessor :placeholder_image

        # @see Widget#set_attributes
        attr_accessor :width

        # @see Widget#set_attributes
        attr_accessor :height

        # @see Widget#set_attributes
        attr_accessor :placeholder_width

        # @see Widget#set_attributes
        attr_accessor :placeholder_height
        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def controller_url_path
          attributes[:controllerUrlPath]
        end

        def controller_url_path=(val)
          attributes[:controllerUrlPath] = val
        end

        def trusted
          attributes[:trusted]
        end

        def trusted=(val)
          attributes[:trusted] = val
        end

        def editor_available
          attributes[:editorAvailable]
        end

        def editor_available=(val)
          attributes[:editorAvailable] = val
        end

        def placeholder_image
          attributes[:placeholderImage]
        end

        def placeholder_image=(val)
          attributes[:placeholderImage] = val
        end

        def width
          attributes[:width]
        end

        def width=(val)
          attributes[:width] = val
        end

        def height
          attributes[:height]
        end

        def height=(val)
          attributes[:height] = val
        end

        def placeholder_width
          attributes[:placeholderWidth]
        end

        def placeholder_width=(val)
          attributes[:placeholderWidth] = val
        end

        def placeholder_height
          attributes[:placeholderHeight]
        end

        def placeholder_height=(val)
          attributes[:placeholderHeight] = val
        end

      end
    end
  end

end
